﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ParallelInvoke
{
    class Program
    {
        // Definícia hlavnej metódy paralelného programu jazyka C#.
        static void Main(string[] args)
        {
            const int size = 10;
            // Tvorba jednorozmerného celočíselného poľa.
            int[] dataArray = new int[size];
            Random generator = new Random();

            // Inicializácia poľa.
            for (int i = 0; i < size; i++)
            {
                dataArray[i] = generator.Next(1, 11);
            }

            // Rýchle spustenie paralelných úloh. 
            Parallel.Invoke(
                () =>
                {
                    // Aktivácia statickej metódy na sumáciu prvkov poľa.
                    int sum = Sum(dataArray);
                    Console.WriteLine("Sum: {0}.", sum);
                },
                () =>
                {
                    // Aktivácia statickej metódy na výpočet aritmetického priemeru prvkov poľa.
                    double avg = Average(dataArray);
                    Console.WriteLine("Average: {0}.", avg);
                },
                () =>
                {
                    // Aktivácia statickej metódy na nájdenie maxima v poli.
                    int max = Max(dataArray);
                    Console.WriteLine("Max: {0}.", max);
                },
                () =>
                {
                    // Aktivácia statickej metódy na detekciu minima v poli.
                    int min = Min(dataArray);
                    Console.WriteLine("Min: {0}.", min);
                });
        }

        // Definícia statickej metódy na výpočet súčtu všetkých prvkov poľa.
        static int Sum(int[] dataArray)
        {
            var sum = (from dataItem in dataArray
                       select dataItem).Sum();
            return sum;
        }

        // Definícia statickej metódy na výpočet aritmetického priemeru zo všetkých prvkov poľa.
        static double Average(int[] dataArray)
        {
            var average = (from dataItem in dataArray
                           select dataItem).Average();
            return average;
        }

        // Definícia statickej metódy na vyhľadanie prvku poľa s maximálnou hodnotou. 
        static int Max(int[] dataArray)
        {
            var max = (from dataItem in dataArray
                       select dataItem).Max();
            return max;
        }

        // Definícia statickej metódy na vyhľadanie prvku poľa s minimálnou hodnotou. 
        static int Min(int[] dataArray)
        {
            var min = (from dataItem in dataArray
                       select dataItem).Min();
            return min;
        }

    }
}
